#
# Defines stages and their order
#

stages:
  - quality
  - test
  - build
  - deploy

#
# Include jobs templates here
#

include:
  - project: sylvanld/gitlab-ci
    ref: main
    file: '/job-template/docker/multiarch.yaml'

  - project: sylvanld/gitlab-ci
    ref: main
    file: '/job-template/kubernetes/apply.yaml'

#
# Jobs to build released packages/images
#

docker-release:
  extends: .docker_release_multiarch
  stage: build
  needs: []
  variables:
    DOCKER_BUILD_PLATFORMS: "linux/amd64,linux/arm64"
    DOCKER_IMAGE_NAME: "sylvanld/cookquick-web"
  
  rules:
    - if: $CI_COMMIT_TAG != null
      when: always
      variables:
        DOCKER_IMAGE_TAG: "$CI_COMMIT_TAG"

    - if: $CI_COMMIT_BRANCH == 'main'
      when: manual
      variables:
        DOCKER_IMAGE_TAG: "latest"

#
# Jobs to deploy new versions of the frontend
#

kubectl-apply:
  extends: .kubectl_apply
  stage: deploy
  needs: []
  variables:
    KUBERNETES_MANIFEST: kubernetes/
    KUBERNETES_NAMESPACE: sylvan-ovh
  when: manual

